source: installer/opengnsys_installer.sh @ 7fb33671

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since 7fb33671 was a37e5fc4, checked in by ramon <ramongomez@…>, 7 years ago

#804: Instalar y actualizar a PHP 7.

git-svn-id: https://opengnsys.es/svn/branches/version1.1@5638 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 58.0 KB
RevLine 
[a01156a]1#!/bin/bash
2
3#####################################################################
[5f21d34]4####### Script instalador OpenGnsys
5####### Autor: Luis Guillén <lguillen@unizar.es>
[a01156a]6#####################################################################
7
8
[9672640]9####  AVISO: Puede editar configuración de acceso por defecto.
10####  WARNING: Edit default access configuration if you wish.
11DEFAULT_MYSQL_ROOT_PASSWORD="passwordroot"      # Clave por defecto root de MySQL
[5f21d34]12DEFAULT_OPENGNSYS_DB_USER="usuog"               # Usuario por defecto de acceso a la base de datos
[9672640]13DEFAULT_OPENGNSYS_DB_PASSWD="passusuog"         # Clave por defecto de acceso a la base de datos
14DEFAULT_OPENGNSYS_CLIENT_PASSWD="og"            # Clave por defecto de acceso del cliente       
[4a3cd1f]15
[1e7eaab]16# Sólo ejecutable por usuario root
[6ef01d9]17if [ "$(whoami)" != 'root' ]; then
[1e7eaab]18        echo "ERROR: this program must run under root privileges!!"
19        exit 1
20fi
[9672640]21
[5f21d34]22echo -e "\\nOpenGnsys Installation"
[9672640]23echo "=============================="
24
25# Clave root de MySQL
26while : ; do
27        echo -n -e "\\nEnter root password for MySQL (${DEFAULT_MYSQL_ROOT_PASSWORD}): ";
[6019b12]28        read -r MYSQL_ROOT_PASSWORD
[9672640]29        if [ -n "${MYSQL_ROOT_PASSWORD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
30                echo -e "\\aERROR: Must be alphanumeric, try again..."
31        else
[6019b12]32                # Si esta vacio ponemos el valor por defecto
33                MYSQL_ROOT_PASSWORD="${MYSQL_ROOT_PASSWORD:-$DEFAULT_MYSQL_ROOT_PASSWORD}"
[9672640]34                break
35        fi
36done
37
38# Usuario de acceso a la base de datos
39while : ; do
[5f21d34]40        echo -n -e "\\nEnter username for OpenGnsys console (${DEFAULT_OPENGNSYS_DB_USER}): "
[6019b12]41        read -r OPENGNSYS_DB_USER
[9672640]42        if [ -n "${OPENGNSYS_DB_USER//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
43                echo -e "\\aERROR: Must be alphanumeric, try again..."
44        else
[6019b12]45                # Si esta vacio ponemos el valor por defecto
46                OPENGNSYS_DB_USER="${OPENGNSYS_DB_USER:-$DEFAULT_OPENGNSYS_DB_USER}"
[9672640]47                break
48        fi
49done
50
51# Clave de acceso a la base de datos
52while : ; do
[5f21d34]53        echo -n -e "\\nEnter password for OpenGnsys console (${DEFAULT_OPENGNSYS_DB_PASSWD}): "
[6019b12]54        read -r OPENGNSYS_DB_PASSWD
[9672640]55        if [ -n "${OPENGNSYS_DB_PASSWD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
56                echo -e "\\aERROR: Must be alphanumeric, try again..."
57        else
[6019b12]58                # Si esta vacio ponemos el valor por defecto
59                OPENGNSYS_DB_PASSWD="${OPENGNSYS_DB_PASSWD:-$DEFAULT_OPENGNSYS_DB_PASSWD}"
[9672640]60                break
61        fi
62done
63
64# Clave de acceso del cliente
65while : ; do
[5f21d34]66        echo -n -e "\\nEnter root password for OpenGnsys client (${DEFAULT_OPENGNSYS_CLIENT_PASSWD}): "
[6019b12]67        read -r OPENGNSYS_CLIENT_PASSWD
[9672640]68        if [ -n "${OPENGNSYS_CLIENT_PASSWD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
69                echo -e "\\aERROR: Must be alphanumeric, try again..."
70        else
[6019b12]71                # Si esta vacio ponemos el valor por defecto
72                OPENGNSYS_CLIENT_PASSWD="${OPENGNSYS_CLIENT_PASSWD:-$DEFAULT_OPENGNSYS_CLIENT_PASSWD}"
[9672640]73                break
74        fi
75done
76
[6019b12]77# Selección de clientes ogLive para descargar.
78while : ; do
79        echo -e "\\nChoose ogLive client to install."
80        echo -e "1) Kernel 4.8, 64-bit"
81        echo -e "2) Kernel 3.2, 32-bit"
82        echo -e "3) Both"
83        echo -n -e "Please, type a valid number (1): "
84        read -r OPT
85        case "$OPT" in
86                1|"")   OGLIVE="ogLive-xenial-4.8.0-39-generic-amd64-r5331.iso"
87                        break ;;
88                2)      OGLIVE="ogLive-precise-3.2.0-23-generic-r5159.iso"
89                        break ;;
90                3)      OGLIVE="ogLive-xenial-4.8.0-39-generic-amd64-r5331.iso ogLive-precise-3.2.0-23-generic-r5159.iso";
91                        break ;;
92                *)      echo -e "\\aERROR: unknown option, try again."
93        esac
94done
95
[9672640]96echo -e "\\n=============================="
[1e7eaab]97
98# Comprobar si se ha descargado el paquete comprimido (USESVN=0) o sólo el instalador (USESVN=1).
[6019b12]99PROGRAMDIR=$(readlink -e "$(dirname "$0")")
[35b0ef1]100PROGRAMNAME=$(basename "$0")
[a0081b7]101OPENGNSYS_SERVER="opengnsys.es"
102DOWNLOADURL="https://$OPENGNSYS_SERVER/trac/downloads"
[1e7eaab]103if [ -d "$PROGRAMDIR/../installer" ]; then
[6ef01d9]104        USESVN=0
[1e7eaab]105else
[6ef01d9]106        USESVN=1
[1e7eaab]107fi
[a0081b7]108SVN_URL="https://$OPENGNSYS_SERVER/svn/branches/version1.1/"
[1e7eaab]109
[a01156a]110WORKDIR=/tmp/opengnsys_installer
[1e7eaab]111mkdir -p $WORKDIR
112
[5f21d34]113# Directorio destino de OpenGnsys.
[1e7eaab]114INSTALL_TARGET=/opt/opengnsys
[6019b12]115PATH=$PATH:$INSTALL_TARGET/bin
[42a0e41]116
117# Registro de incidencias.
118OGLOGFILE=$INSTALL_TARGET/log/${PROGRAMNAME%.sh}.log
[acfb07d]119LOG_FILE=/tmp/$(basename $OGLOGFILE)
[a01156a]120
[fd021b0]121# Usuario del cliente para acceso remoto.
122OPENGNSYS_CLIENT_USER="opengnsys"
123
124# Nombre de la base datos y fichero SQL para su creación.
125OPENGNSYS_DATABASE="ogAdmBD"
126OPENGNSYS_DB_CREATION_FILE=opengnsys/admin/Database/${OPENGNSYS_DATABASE}.sql
[3aaf91d]127
[a01156a]128
129#####################################################################
[d168a46]130####### Funciones de configuración
131#####################################################################
132
133# Generar variables de configuración del instalador
134# Variables globales:
[5cc52295]135# - OSDISTRIB, OSVERSION - tipo y versión de la distribución GNU/Linux
[d168a46]136# - DEPENDENCIES - array de dependencias que deben estar instaladas
137# - UPDATEPKGLIST, INSTALLPKGS, CHECKPKGS - comandos para gestión de paquetes
[109e8b2]138# - INSTALLEXTRADEPS - instalar dependencias no incluidas en la distribución
[53fba30]139# - STARTSERVICE, ENABLESERVICE - iniciar y habilitar un servicio
[109e8b2]140# - STOPSERVICE, DISABLESERVICE - parar y deshabilitar un servicio
[53fba30]141# - APACHESERV, APACHECFGDIR, APACHESITESDIR, APACHEUSER, APACHEGROUP - servicio y configuración de Apache
[7825e9e]142# - APACHESSLMOD, APACHEENABLESSL, APACHEMAKECERT - habilitar módulo Apache y certificado SSL
[5f21d34]143# - APACHEENABLEOG, APACHEOGSITE, - habilitar sitio web de OpenGnsys
[53fba30]144# - INETDSERV - servicio Inetd
[09ac3b8]145# - FIREWALLSERV - servicio de cortabuegos IPTables/FirewallD
[53fba30]146# - DHCPSERV, DHCPCFGDIR - servicio y configuración de DHCP
[0f8100d]147# - MYSQLSERV, TMPMYCNF - servicio MySQL y fichero temporal con credenciales de acceso
148# - MARIADBSERV - servicio MariaDB (sustituto de MySQL en algunas distribuciones)
[e70925a]149# - RSYNCSERV, RSYNCCFGDIR - servicio y configuración de Rsync
[53fba30]150# - SAMBASERV, SAMBACFGDIR - servicio y configuración de Samba
[a16ce1b]151# - TFTPSERV, TFTPCFGDIR - servicio y configuración de TFTP/PXE
[d168a46]152function autoConfigure()
153{
[44f6582]154# Detectar sistema operativo del servidor (compatible con fichero os-release y con LSB).
155if [ -f /etc/os-release ]; then
156        source /etc/os-release
[eb7b39d]157        OSDISTRIB="$ID"
[5cc52295]158        OSVERSION="$VERSION_ID"
[44f6582]159else
160        OSDISTRIB=$(lsb_release -is 2>/dev/null)
[5cc52295]161        OSVERSION=$(lsb_release -rs 2>/dev/null)
[44f6582]162fi
[5cc52295]163# Convertir distribución a minúsculas y obtener solo el 1er número de versión.
[eb7b39d]164OSDISTRIB="${OSDISTRIB,,}"
[5cc52295]165OSVERSION="${OSVERSION%%.*}"
[d168a46]166
[eb7b39d]167# Configuración según la distribución GNU/Linux (usar minúsculas).
[d168a46]168case "$OSDISTRIB" in
[eb7b39d]169        ubuntu|debian|linuxmint)
[a37e5fc4]170                DEPENDENCIES=( subversion apache2 php php-ldap libapache2-mod-php mysql-server php-mysql isc-dhcp-server bittorrent tftp-hpa tftpd-hpa xinetd build-essential g++-multilib libmysqlclient15-dev wget curl doxygen graphviz bittornado ctorrent samba rsync unzip netpipes debootstrap schroot squashfs-tools btrfs-tools procps arp-scan realpath php-curl gettext moreutils jq wakeonlan )
[d168a46]171                UPDATEPKGLIST="apt-get update"
172                INSTALLPKG="apt-get -y install --force-yes"
173                CHECKPKG="dpkg -s \$package 2>/dev/null | grep Status | grep -qw install"
[53fba30]174                if which service &>/dev/null; then
[7ba85a4]175                        STARTSERVICE="eval service \$service restart"
[109e8b2]176                        STOPSERVICE="eval service \$service stop"
[53fba30]177                else
[7ba85a4]178                        STARTSERVICE="eval /etc/init.d/\$service restart"
[109e8b2]179                        STOPSERVICE="eval /etc/init.d/\$service stop"
[53fba30]180                fi
[7ba85a4]181                ENABLESERVICE="eval update-rc.d \$service defaults"
[109e8b2]182                DISABLESERVICE="eval update-rc.d \$service disable"
[53fba30]183                APACHESERV=apache2
[d168a46]184                APACHECFGDIR=/etc/apache2
[643ca8c]185                APACHESITESDIR=sites-available
[53fba30]186                APACHEOGSITE=opengnsys
[d168a46]187                APACHEUSER="www-data"
188                APACHEGROUP="www-data"
[7ba85a4]189                APACHESSLMOD="a2enmod ssl"
[7829e4e]190                APACHEREWRITEMOD="a2enmod rewrite"
[7ba85a4]191                APACHEENABLESSL="a2ensite default-ssl"
[53fba30]192                APACHEENABLEOG="a2ensite $APACHEOGSITE"
[643ca8c]193                APACHEMAKECERT="make-ssl-cert generate-default-snakeoil --force-overwrite"
[53fba30]194                DHCPSERV=isc-dhcp-server
[83518d5]195                DHCPCFGDIR=/etc/dhcp
[f243a47]196                INETDSERV=xinetd
197                INETDCFGDIR=/etc/xinetd.d
[53fba30]198                MYSQLSERV=mysql
[0f8100d]199                MARIADBSERV=mariadb
[e70925a]200                RSYNCSERV=rsync
201                RSYNCCFGDIR=/etc
[53fba30]202                SAMBASERV=smbd
[d168a46]203                SAMBACFGDIR=/etc/samba
204                TFTPCFGDIR=/var/lib/tftpboot
205                ;;
[eb7b39d]206        fedora|centos)
[325aac9]207                DEPENDENCIES=( subversion httpd mod_ssl php php-ldap mysql-server mysql-devel mysql-devel.i686 php-mysql dhcp tftp-server tftp xinetd binutils gcc gcc-c++ glibc-devel glibc-devel.i686 glibc-static glibc-static.i686 libstdc++-devel.i686 make wget curl doxygen graphviz ctorrent samba samba-client rsync unzip debootstrap schroot squashfs-tools python-crypto arp-scan procps-ng gettext moreutils jq net-tools http://ftp.altlinux.org/pub/distributions/ALTLinux/5.1/branch/$(arch)/RPMS.classic/netpipes-4.2-alt1.$(arch).rpm )
208                INSTALLEXTRADEPS=( 'pushd /tmp; wget -t3 http://download.bittornado.com/download/BitTornado-0.3.18.tar.gz && tar xvzf BitTornado-0.3.18.tar.gz && cd BitTornado-CVS && python setup.py install && ln -fs btlaunchmany.py /usr/bin/btlaunchmany && ln -fs bttrack.py /usr/bin/bttrack; popd' )
209                INSTALLPKG="yum install -y libstdc++ libstdc++.i686"
[c79a2b3]210                CHECKPKG="rpm -q --quiet \$package"
[03cfd6e]211                SYSTEMD=$(which systemctl 2>/dev/null)
212                if [ -n "$SYSTEMD" ]; then
213                        STARTSERVICE="eval systemctl start \$service.service"
214                        STOPSERVICE="eval systemctl stop \$service.service"
215                        ENABLESERVICE="eval systemctl enable \$service.service"
216                        DISABLESERVICE="eval systemctl disable \$service.service"
217                else
218                        STARTSERVICE="eval service \$service start"
219                        STOPSERVICE="eval service \$service stop"
220                        ENABLESERVICE="eval chkconfig \$service on"
221                        DISABLESERVICE="eval chkconfig \$service off"
222                fi
[53fba30]223                APACHESERV=httpd
[d168a46]224                APACHECFGDIR=/etc/httpd/conf.d
[53fba30]225                APACHEOGSITE=opengnsys.conf
[d168a46]226                APACHEUSER="apache"
227                APACHEGROUP="apache"
[5f21d34]228                APACHEREWRITEMOD="sed -i '/rewrite/s/^#//' $APACHECFGDIR/../*.conf"
[53fba30]229                DHCPSERV=dhcpd
[d168a46]230                DHCPCFGDIR=/etc/dhcp
[09ac3b8]231                if firewall-cmd --state &>/dev/null; then
232                        FIREWALLSERV=firewalld
233                else
234                        FIREWALLSERV=iptables
235                fi
[53fba30]236                INETDSERV=xinetd
[f243a47]237                INETDCFGDIR=/etc/xinetd.d
[53fba30]238                MYSQLSERV=mysqld
[0f8100d]239                MARIADBSERV=mariadb
[e70925a]240                RSYNCSERV=rsync
241                RSYNCCFGDIR=/etc
[53fba30]242                SAMBASERV=smb
[d168a46]243                SAMBACFGDIR=/etc/samba
[53fba30]244                TFTPSERV=tftp
[d168a46]245                TFTPCFGDIR=/var/lib/tftpboot
246                ;;
247        "")     echo "ERROR: Unknown Linux distribution, please install \"lsb_release\" command."
248                exit 1 ;;
[5f21d34]249        *)      echo "ERROR: Distribution not supported by OpenGnsys."
[d168a46]250                exit 1 ;;
251esac
[09bf701]252
253# Fichero de credenciales de acceso a MySQL.
254TMPMYCNF=/tmp/.my.cnf.$$
[d168a46]255}
256
[09ac3b8]257
[ff6c349]258# Modificar variables de configuración tras instalar paquetes del sistema.
259function autoConfigurePost()
260{
[09ac3b8]261local f
262
[44f6582]263# Configuraciones específicas para Samba y TFTP en Debian 6.
264[ -z "$SYSTEMD" -a ! -e /etc/init.d/$SAMBASERV ] && SAMBASERV=samba
265[ ! -e $TFTPCFGDIR ] && TFTPCFGDIR=/srv/tftp
266
[09ac3b8]267# Configuraciones específicas para SELinux permisivo en distintas versiones.
[44f6582]268[ -f /selinux/enforce ] && echo 0 > /selinux/enforce
[e5f9c147]269for f in /etc/sysconfig/selinux /etc/selinux/config; do
[4fdf2b1]270        [ -f $f ] && perl -pi -e 's/SELINUX=enforcing/SELINUX=permissive/g' $f
[09ac3b8]271done
272selinuxenabled 2>/dev/null && setenforce 0 2>/dev/null
[ff6c349]273}
274
275
[83518d5]276# Cargar lista de paquetes del sistema y actualizar algunas variables de configuración
277# dependiendo de la versión instalada.
278function updatePackageList()
279{
[a37e5fc4]280local DHCPVERSION PHP7VERSION
[83518d5]281
282# Si es necesario, actualizar la lista de paquetes disponibles.
283[ -n "$UPDATEPKGLIST" ] && eval $UPDATEPKGLIST
284
285# Configuración personallizada de algunos paquetes.
286case "$OSDISTRIB" in
[eb7b39d]287        ubuntu|linuxmint)       # Postconfiguación personalizada para Ubuntu.
[83518d5]288                # Configuración para DHCP v3.
[e4b1572]289                DHCPVERSION=$(apt-cache show $(apt-cache pkgnames|egrep "dhcp.?-server$") | \
[83518d5]290                              awk '/Version/ {print substr($2,1,1);}' | \
291                              sort -n | tail -1)
292                if [ $DHCPVERSION = 3 ]; then
[e4b1572]293                        DEPENDENCIES=( ${DEPENDENCIES[@]/isc-dhcp-server/dhcp3-server} )
[53fba30]294                        DHCPSERV=dhcp3-server
[83518d5]295                        DHCPCFGDIR=/etc/dhcp3
296                fi
[a37e5fc4]297                # Configuración para PHP 7 en Ubuntu.
298                if [ -z "$(apt-cache pkgnames php7)" ]; then
[668f7dc]299                        eval $INSTALLPKG software-properties-common
[21f78d1]300                        add-apt-repository -y ppa:ondrej/php
[668f7dc]301                        eval $UPDATEPKGLIST
[ad69c61]302                fi
[a37e5fc4]303                PHP7VERSION=$(apt-cache pkgnames php7 | sort | head -1)
304                DEPENDENCIES=( ${DEPENDENCIES[@]//php/$PHP7VERSION} )
[ad69c61]305                # Dependencias correctas para libmysqlclient.
[21f78d1]306                [ -z "$(apt-cache pkgnames libmysqlclient15)" ] && DEPENDENCIES=( ${DEPENDENCIES[@]//libmysqlclient15/libmysqlclient} )
[83518d5]307                ;;
[eb7b39d]308        centos) # Postconfiguación personalizada para CentOS.
[a37e5fc4]309                # Configuración para PHP 7.
310                if ! yum list php7 &>/dev/null; then
311                        if [ $OSVERSION -lt 7 ]; then
[325aac9]312                                yum install -y https://mirror.webtatic.com/yum/el$OSVERSION/latest.rpm
[a37e5fc4]313                                PHP7VERSION=$(yum list -q php7\*w | awk -F. '/^php/ {p=$1} END {print p}')
314                                DEPENDENCIES=( ${DEPENDENCIES[@]//php/$PHP5VERSION} )
[325aac9]315                        fi
316                fi
[2c8b9ed]317                # Cambios a aplicar a partir de CentOS 7.
318                if [ $OSVERSION -ge 7 ]; then
319                        # Sustituir MySQL por MariaDB.
320                        DEPENDENCIES=( ${DEPENDENCIES[*]/mysql-/mariadb-} )
[325aac9]321                        # Instalar ctorrent de EPEL para CentOS 6 (no disponible en CentOS 7).
322                        DEPENDENCIES=( ${DEPENDENCIES[*]/ctorrent/http://dl.fedoraproject.org/pub/epel/6/$(arch)/Packages/c/ctorrent-1.3.4-14.dnh3.3.2.el6.$(arch).rpm} )
[2c8b9ed]323                fi
[c525453]324                ;;
[eb7b39d]325        fedora) # Postconfiguación personalizada para Fedora.
[c525453]326                # Incluir paquetes específicos.
[325aac9]327                DEPENDENCIES=( ${DEPENDENCIES[@]} btrfs-progs )
[5cc52295]328                # Sustituir MySQL por MariaDB a partir de Fedora 20.
329                [ $OSVERSION -ge 20 ] && DEPENDENCIES=( ${DEPENDENCIES[*]/mysql-/mariadb-} )
[c79a2b3]330                ;;
[83518d5]331esac
332}
333
[d168a46]334
335#####################################################################
[a01156a]336####### Algunas funciones útiles de propósito general:
337#####################################################################
[d168a46]338
[13a01a7]339function getDateTime()
[a01156a]340{
[d168a46]341        date "+%Y%m%d-%H%M%S"
[a01156a]342}
343
344# Escribe a fichero y muestra por pantalla
[13a01a7]345function echoAndLog()
[a01156a]346{
[d168a46]347        local DATETIME=`getDateTime`
[87c7b02]348        echo "$1"
[d168a46]349        echo "$DATETIME;$SSH_CLIENT;$1" >> $LOG_FILE
[a01156a]350}
351
[87c7b02]352# Escribe a fichero y muestra mensaje de error
[13a01a7]353function errorAndLog()
[a01156a]354{
[d168a46]355        local DATETIME=`getDateTime`
[87c7b02]356        echo "ERROR: $1"
[d168a46]357        echo "$DATETIME;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
[a01156a]358}
359
[346eaee]360# Escribe a fichero y muestra mensaje de aviso
361function warningAndLog()
362{
363        local DATETIME=`getDateTime`
[cd86637]364        echo "Warning: $1"
[346eaee]365        echo "$DATETIME;$SSH_CLIENT;Warning: $1" >> $LOG_FILE
366}
367
[87c7b02]368# Comprueba si el elemento pasado en $2 está en el array $1
[13a01a7]369function isInArray()
[a01156a]370{
371        if [ $# -ne 2 ]; then
[13a01a7]372                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]373                exit 1
374        fi
375
376        local deps
[87c7b02]377        local is_in_array=1
378        local element="$2"
379
380        echoAndLog "${FUNCNAME}(): checking if $2 is in $1"
[5c33840]381        eval "deps=( \"\${$1[@]}\" )"
[a01156a]382
[87c7b02]383        # Copia local del array del parámetro 1.
384        for (( i = 0 ; i < ${#deps[@]} ; i++ )); do
385                if [ "${deps[$i]}" = "${element}" ]; then
386                        echoAndLog "isInArray(): $element found in array"
[a01156a]387                        is_in_array=0
388                fi
389        done
390
391        if [ $is_in_array -ne 0 ]; then
[87c7b02]392                echoAndLog "${FUNCNAME}(): $element NOT found in array"
[a01156a]393        fi
394
395        return $is_in_array
396}
397
[87c7b02]398
[a01156a]399#####################################################################
400####### Funciones de manejo de paquetes Debian
401#####################################################################
402
[13a01a7]403function checkPackage()
[a01156a]404{
405        package=$1
406        if [ -z $package ]; then
[73cfa0a]407                errorAndLog "${FUNCNAME}(): parameter required"
[a01156a]408                exit 1
409        fi
[73cfa0a]410        echoAndLog "${FUNCNAME}(): checking if package $package exists"
[d168a46]411        eval $CHECKPKG
[a01156a]412        if [ $? -eq 0 ]; then
[73cfa0a]413                echoAndLog "${FUNCNAME}(): package $package exists"
[a01156a]414                return 0
415        else
[73cfa0a]416                echoAndLog "${FUNCNAME}(): package $package doesn't exists"
[a01156a]417                return 1
418        fi
419}
420
[87c7b02]421# Recibe array con dependencias
[a01156a]422# por referencia deja un array con las dependencias no resueltas
423# devuelve 1 si hay alguna dependencia no resuelta
[13a01a7]424function checkDependencies()
[a01156a]425{
426        if [ $# -ne 2 ]; then
[73cfa0a]427                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]428                exit 1
429        fi
430
[73cfa0a]431        echoAndLog "${FUNCNAME}(): checking dependences"
[a01156a]432        uncompletedeps=0
433
434        # copia local del array del parametro 1
435        local deps
[5c33840]436        eval "deps=( \"\${$1[@]}\" )"
[a01156a]437
438        declare -a local_notinstalled
[5c33840]439
[a01156a]440        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
441        do
442                checkPackage ${deps[$i]}
443                if [ $? -ne 0 ]; then
444                        local_notinstalled[$uncompletedeps]=$package
445                        let uncompletedeps=uncompletedeps+1
446                fi
447        done
448
449        # relleno el array especificado en $2 por referencia
450        for (( i = 0 ; i < ${#local_notinstalled[@]} ; i++ ))
451        do
452                eval "${2}[$i]=${local_notinstalled[$i]}"
453        done
454
455        # retorna el numero de paquetes no resueltos
[73cfa0a]456        echoAndLog "${FUNCNAME}(): dependencies uncompleted: $uncompletedeps"
[a01156a]457        return $uncompletedeps
458}
459
460# Recibe un array con las dependencias y lo instala
[13a01a7]461function installDependencies()
[a01156a]462{
463        if [ $# -ne 1 ]; then
[813f617]464                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]465                exit 1
466        fi
[813f617]467        echoAndLog "${FUNCNAME}(): installing uncompleted dependencies"
[a01156a]468
469        # copia local del array del parametro 1
470        local deps
[5c33840]471        eval "deps=( \"\${$1[@]}\" )"
[a01156a]472
473        local string_deps=""
474        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
475        do
476                string_deps="$string_deps ${deps[$i]}"
477        done
478
479        if [ -z "${string_deps}" ]; then
[813f617]480                errorAndLog "${FUNCNAME}(): array of dependeces is empty"
[a01156a]481                exit 1
482        fi
483
[c79a2b3]484        OLD_DEBIAN_FRONTEND=$DEBIAN_FRONTEND            # Debian/Ubuntu
[a01156a]485        export DEBIAN_FRONTEND=noninteractive
486
[d168a46]487        echoAndLog "${FUNCNAME}(): now $string_deps will be installed"
488        eval $INSTALLPKG $string_deps
[a01156a]489        if [ $? -ne 0 ]; then
[813f617]490                errorAndLog "${FUNCNAME}(): error installing dependencies"
[a01156a]491                return 1
492        fi
493
[c79a2b3]494        DEBIAN_FRONTEND=$OLD_DEBIAN_FRONTEND            # Debian/Ubuntu
[6019b12]495        test grep -q "EPEL temporal" /etc/yum.repos.d/epel.repo 2>/dev/null || mv -f /etc/yum.repos.d/epel.repo.rpmnew /etc/yum.repos.d/epel.repo 2>/dev/null   # CentOS/RedHat EPEL
[c79a2b3]496
[813f617]497        echoAndLog "${FUNCNAME}(): dependencies installed"
[a01156a]498}
499
[13a01a7]500# Hace un backup del fichero pasado por parámetro
501# deja un -last y uno para el día
502function backupFile()
503{
504        if [ $# -ne 1 ]; then
505                errorAndLog "${FUNCNAME}(): invalid number of parameters"
506                exit 1
507        fi
508
[d168a46]509        local file="$1"
510        local dateymd=`date +%Y%m%d`
[13a01a7]511
[d168a46]512        if [ ! -f "$file" ]; then
[346eaee]513                warningAndLog "${FUNCNAME}(): file $file doesn't exists"
[13a01a7]514                return 1
515        fi
516
[d168a46]517        echoAndLog "${FUNCNAME}(): making $file backup"
[13a01a7]518
519        # realiza una copia de la última configuración como last
[d168a46]520        cp -a "$file" "${file}-LAST"
[13a01a7]521
522        # si para el día no hay backup lo hace, sino no
[d168a46]523        if [ ! -f "${file}-${dateymd}" ]; then
524                cp -a "$file" "${file}-${dateymd}"
[13a01a7]525        fi
526
[d168a46]527        echoAndLog "${FUNCNAME}(): $file backup success"
[13a01a7]528}
529
[a01156a]530#####################################################################
531####### Funciones para el manejo de bases de datos
532#####################################################################
533
534# This function set password to root
[13a01a7]535function mysqlSetRootPassword()
[a01156a]536{
537        if [ $# -ne 1 ]; then
[813f617]538                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]539                exit 1
540        fi
541
[e0edc14]542        local root_mysql="$1"
[813f617]543        echoAndLog "${FUNCNAME}(): setting root password in MySQL server"
[e0edc14]544        mysqladmin -u root password "$root_mysql"
[a01156a]545        if [ $? -ne 0 ]; then
[813f617]546                errorAndLog "${FUNCNAME}(): error while setting root password in MySQL server"
[a01156a]547                return 1
548        fi
[813f617]549        echoAndLog "${FUNCNAME}(): root password saved!"
[a01156a]550        return 0
551}
552
[892606b9]553# Si el servicio mysql esta ya instalado cambia la variable de la clave del root por la ya existente
[e0edc14]554function mysqlGetRootPassword()
555{
[892606b9]556        local pass_mysql
557        local pass_mysql2
[7c54b49]558        # Comprobar si MySQL está instalado con la clave de root por defecto.
559        if mysql -u root -p"$MYSQL_ROOT_PASSWORD" <<<"quit" 2>/dev/null; then
560                echoAndLog "${FUNCNAME}(): Using default mysql root password."
561        else
562                stty -echo
[e0edc14]563                echo "There is a MySQL service already installed."
564                read -p "Enter MySQL root password: " pass_mysql
[7c54b49]565                echo ""
[e0edc14]566                read -p "Confrim password:" pass_mysql2
[7c54b49]567                echo ""
568                stty echo
569                if [ "$pass_mysql" == "$pass_mysql2" ] ;then
[e0edc14]570                        MYSQL_ROOT_PASSWORD="$pass_mysql"
[7c54b49]571                        return 0
572                else
[e0edc14]573                        echo "The keys don't match. Do not configure the server's key,"
574                        echo "transactions in the database will give error."
[7c54b49]575                        return 1
576                fi
[892606b9]577        fi
578}
579
[a01156a]580# comprueba si puede conectar con mysql con el usuario root
581function mysqlTestConnection()
582{
583        if [ $# -ne 1 ]; then
[e0edc14]584                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]585                exit 1
586        fi
587
[09bf701]588        local root_password="$1"
[e0edc14]589        echoAndLog "${FUNCNAME}(): checking connection to mysql..."
[09bf701]590        # Componer fichero con credenciales de conexión a MySQL.
591        touch $TMPMYCNF
592        chmod 600 $TMPMYCNF
593        cat << EOT > $TMPMYCNF
[c073224]594[client]
[09bf701]595user=root
596password=$root_password
597EOT
598        # Borrar el fichero temporal si termina el proceso de instalación.
599        trap "rm -f $TMPMYCNF" 0 1 2 3 6 9 15
600        # Comprobar conexión a MySQL.
601        echo "" | mysql --defaults-extra-file=$TMPMYCNF
[a01156a]602        if [ $? -ne 0 ]; then
[e0edc14]603                errorAndLog "${FUNCNAME}(): connection to mysql failed, check root password and if daemon is running!"
[a01156a]604                return 1
605        else
[e0edc14]606                echoAndLog "${FUNCNAME}(): connection success"
[a01156a]607                return 0
608        fi
609}
610
611# comprueba si la base de datos existe
612function mysqlDbExists()
613{
[09bf701]614        if [ $# -ne 1 ]; then
[e0edc14]615                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]616                exit 1
617        fi
618
[09bf701]619        local database="$1"
[e0edc14]620        echoAndLog "${FUNCNAME}(): checking if $database exists..."
[09bf701]621        echo "show databases" | mysql --defaults-extra-file=$TMPMYCNF | grep "^${database}$"
[a01156a]622        if [ $? -ne 0 ]; then
[e0edc14]623                echoAndLog "${FUNCNAME}():database $database doesn't exists"
[a01156a]624                return 1
625        else
[e0edc14]626                echoAndLog "${FUNCNAME}():database $database exists"
[a01156a]627                return 0
628        fi
629}
630
[0a735488]631# Comprueba si la base de datos está vacía.
[a01156a]632function mysqlCheckDbIsEmpty()
633{
[09bf701]634        if [ $# -ne 1 ]; then
[e0edc14]635                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]636                exit 1
637        fi
638
[09bf701]639        local database="$1"
[e0edc14]640        echoAndLog "${FUNCNAME}(): checking if $database is empty..."
[09bf701]641        num_tablas=`echo "show tables" | mysql --defaults-extra-file=$TMPMYCNF "${database}" | wc -l`
[a01156a]642        if [ $? -ne 0 ]; then
[e0edc14]643                errorAndLog "${FUNCNAME}(): error executing query, check database and root password"
[a01156a]644                exit 1
645        fi
646
647        if [ $num_tablas -eq 0 ]; then
[e0edc14]648                echoAndLog "${FUNCNAME}():database $database is empty"
[a01156a]649                return 0
650        else
[e0edc14]651                echoAndLog "${FUNCNAME}():database $database has tables"
[a01156a]652                return 1
653        fi
654
655}
656
[0a735488]657# Importa un fichero SQL en la base de datos.
658# Parámetros:
659# - 1: nombre de la BD.
660# - 2: fichero a importar.
661# Nota: el fichero SQL puede contener las siguientes palabras reservadas:
662# - SERVERIP: se sustituye por la dirección IP del servidor.
663# - DBUSER: se sustituye por usuario de conexión a la BD definido en este script.
664# - DBPASSWD: se sustituye por la clave de conexión a la BD definida en este script.
[a01156a]665function mysqlImportSqlFileToDb()
666{
[09bf701]667        if [ $# -ne 2 ]; then
[c5ce04c]668                errorAndLog "${FNCNAME}(): invalid number of parameters"
[a01156a]669                exit 1
670        fi
671
[09bf701]672        local database="$1"
673        local sqlfile="$2"
[c4321ae]674        local tmpfile=$(mktemp)
[d168a46]675        local i=0
676        local dev=""
[c4321ae]677        local status
[8e0f770]678        # Claves aleatorias para acceso a las APIs REST.
[7829e4e]679        local OPENGNSYS_APIKEY=$(php -r 'echo md5(uniqid(rand(), true));')
[f9b5714]680        OPENGNSYS_REPOKEY=$(php -r 'echo md5(uniqid(rand(), true));')
[a01156a]681
682        if [ ! -f $sqlfile ]; then
[c5ce04c]683                errorAndLog "${FUNCNAME}(): Unable to locate $sqlfile!!"
[a01156a]684                return 1
685        fi
686
[d168a46]687        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
[c4321ae]688        chmod 600 $tmpfile
[d168a46]689        for dev in ${DEVICE[*]}; do
[73a1bd6]690                if [ "${DEVICE[i]}" == "$DEFAULTDEV" ]; then
[d168a46]691                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
692                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
693                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
[7829e4e]694                            -e "s/APIKEY/$OPENGNSYS_APIKEY/g" \
[8e0f770]695                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
[d168a46]696                                $sqlfile > $tmpfile
697                fi
698                let i++
699        done
[09bf701]700        mysql --defaults-extra-file=$TMPMYCNF --default-character-set=utf8 "${database}" < $tmpfile
[c4321ae]701        status=$?
702        rm -f $tmpfile
703        if [ $status -ne 0 ]; then
[c5ce04c]704                errorAndLog "${FUNCNAME}(): error while importing $sqlfile in database $database"
[a01156a]705                return 1
706        fi
[c5ce04c]707        echoAndLog "${FUNCNAME}(): file imported to database $database"
[a01156a]708        return 0
709}
710
711# Crea la base de datos
712function mysqlCreateDb()
713{
[09bf701]714        if [ $# -ne 1 ]; then
[a555f49]715                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]716                exit 1
717        fi
718
[09bf701]719        local database="$1"
[a01156a]720
[a555f49]721        echoAndLog "${FUNCNAME}(): creating database..."
[09bf701]722        mysqladmin --defaults-extra-file=$TMPMYCNF create $database
[a01156a]723        if [ $? -ne 0 ]; then
[a555f49]724                errorAndLog "${FUNCNAME}(): error while creating database $database"
[a01156a]725                return 1
726        fi
[e47e131]727        # Quitar modo ONLY_FULL_GROUP_BY de MySQL (ticket #730).
728        mysql --defaults-extra-file=$TMPMYCNF -e "SET GLOBAL sql_mode=(SELECT TRIM(BOTH ',' FROM REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')));"
729
[a555f49]730        echoAndLog "${FUNCNAME}(): database $database created"
[a01156a]731        return 0
732}
733
[0a735488]734# Comprueba si ya está definido el usuario de acceso a la BD.
[a01156a]735function mysqlCheckUserExists()
736{
[09bf701]737        if [ $# -ne 1 ]; then
[e0edc14]738                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]739                exit 1
740        fi
741
[09bf701]742        local userdb="$1"
[a01156a]743
[e0edc14]744        echoAndLog "${FUNCNAME}(): checking if $userdb exists..."
[09bf701]745        echo "select user from user where user='${userdb}'\\G" |mysql --defaults-extra-file=$TMPMYCNF mysql | grep user
[a01156a]746        if [ $? -ne 0 ]; then
[e0edc14]747                echoAndLog "${FUNCNAME}(): user doesn't exists"
[a01156a]748                return 1
749        else
[e0edc14]750                echoAndLog "${FUNCNAME}(): user already exists"
[a01156a]751                return 0
752        fi
753
754}
755
756# Crea un usuario administrativo para la base de datos
757function mysqlCreateAdminUserToDb()
758{
[09bf701]759        if [ $# -ne 3 ]; then
[e0edc14]760                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]761                exit 1
762        fi
763
[09bf701]764        local database="$1"
765        local userdb="$2"
766        local passdb="$3"
[a01156a]767
[e0edc14]768        echoAndLog "${FUNCNAME}(): creating admin user ${userdb} to database ${database}"
[a01156a]769
770        cat > $WORKDIR/create_${database}.sql <<EOF
771GRANT USAGE ON *.* TO '${userdb}'@'localhost' IDENTIFIED BY '${passdb}' ;
772GRANT ALL PRIVILEGES ON ${database}.* TO '${userdb}'@'localhost' WITH GRANT OPTION ;
773FLUSH PRIVILEGES ;
774EOF
[09bf701]775        mysql --defaults-extra-file=$TMPMYCNF < $WORKDIR/create_${database}.sql
[a01156a]776        if [ $? -ne 0 ]; then
[e0edc14]777                errorAndLog "${FUNCNAME}(): error while creating user in mysql"
[a01156a]778                rm -f $WORKDIR/create_${database}.sql
779                return 1
780        else
[e0edc14]781                echoAndLog "${FUNCNAME}(): user created ok"
[a01156a]782                rm -f $WORKDIR/create_${database}.sql
783                return 0
784        fi
785}
786
787
788#####################################################################
789####### Funciones para el manejo de Subversion
790#####################################################################
791
[0a735488]792# Obtiene el código fuente del proyecto desde el servidor SVN.
[13a01a7]793function svnExportCode()
794{
795        if [ $# -ne 1 ]; then
796                errorAndLog "${FUNCNAME}(): invalid number of parameters"
797                exit 1
798        fi
799
[6090a2d]800        local url="$1"
[13a01a7]801
802        echoAndLog "${FUNCNAME}(): downloading subversion code..."
803
[6090a2d]804        svn export --force "$url" opengnsys
[13a01a7]805        if [ $? -ne 0 ]; then
[5f21d34]806                errorAndLog "${FUNCNAME}(): error getting OpenGnsys code from $url"
[13a01a7]807                return 1
808        fi
809        echoAndLog "${FUNCNAME}(): subversion code downloaded"
810        return 0
811}
812
813
[892606b9]814############################################################
[7586ca3]815###  Detectar red
816############################################################
817
[07c3a59]818# Comprobar si existe conexión.
819function checkNetworkConnection()
820{
[09ac3b8]821        echoAndLog "${FUNCNAME}(): Disabling Firewall: $FIREWALLSERV."
822        if [ -n "$FIREWALLSERV" ]; then
823                service=$FIREWALLSERV
[b83843c]824                $STOPSERVICE; $DISABLESERVICE
825        fi
[109e8b2]826
[5f21d34]827        echoAndLog "${FUNCNAME}(): Checking OpenGnsys server conectivity."
[a0081b7]828        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"opengnsys.es"}
[225e859]829        if which wget &>/dev/null; then
830                wget --spider -q $OPENGNSYS_SERVER
831        elif which curl &>/dev/null; then
832                curl --connect-timeout 10 -s $OPENGNSYS_SERVER -o /dev/null
833        else
834                echoAndLog "${FUNCNAME}(): Cannot execute \"wget\" nor \"curl\"."
835                return 1
836        fi
[07c3a59]837}
838
[140fbd5]839# Convierte nº de bits (notación CIDR) en máscara de red (gracias a FriedZombie en openwrt.org).
840cidr2mask ()
841{
842        # Number of args to shift, 255..255, first non-255 byte, zeroes
843        set -- $[ 5 - ($1 / 8) ] 255 255 255 255 $[ (255 << (8 - ($1 % 8))) & 255 ] 0 0 0
844        [ $1 -gt 1 ] && shift $1 || shift
845        echo ${1-0}.${2-0}.${3-0}.${4-0}
846}
847
[07c3a59]848# Obtener los parámetros de red de la interfaz por defecto.
[7586ca3]849function getNetworkSettings()
850{
[d168a46]851        # Arrays globales definidas:
852        # - DEVICE:     nombres de dispositivos de red activos.
853        # - SERVERIP:   IPs locales del servidor.
854        # - NETIP:      IPs de redes.
855        # - NETMASK:    máscaras de red.
856        # - NETBROAD:   IPs de difusión de redes.
857        # - ROUTERIP:   IPs de routers.
858        # Otras variables globales:
859        # - DEFAULTDEV: dispositivo de red por defecto.
860        # - DNSIP:      IP del servidor DNS principal.
861
862        local i=0
863        local dev=""
864
[109e8b2]865        echoAndLog "${FUNCNAME}(): Detecting network parameters."
[d168a46]866        DEVICE=( $(ip -o link show up | awk '!/loopback/ {sub(/:.*/,"",$2); print $2}') )
867        if [ -z "$DEVICE" ]; then
868                errorAndLog "${FUNCNAME}(): Network devices not detected."
[62e3bcf]869                exit 1
870        fi
[d168a46]871        for dev in ${DEVICE[*]}; do
[140fbd5]872                SERVERIP[i]=$(ip -o addr show dev "$dev" | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4)}')
[d168a46]873                if [ -n "${SERVERIP[i]}" ]; then
[140fbd5]874                        NETMASK[i]=$( cidr2mask $(ip -o addr show dev "$dev" | awk '$3~/inet$/ {sub (/.*\//, "", $4); print ($4)}') )
875                        NETBROAD[i]=$(ip -o addr show dev "$dev" | awk '$3~/inet$/ {print ($6)}')
[826d576]876                        NETIP[i]=$(ip route | awk -v d="$dev" '$3==d && /src/ {sub (/\/.*/,""); print $1}')
877                        ROUTERIP[i]=$(ip route | awk -v d="$dev" '$1=="default" && $5==d {print $3}')
[d168a46]878                        DEFAULTDEV=${DEFAULTDEV:-"$dev"}
879                fi
[ce85ae8]880                let i++
[d168a46]881        done
[a555f49]882        DNSIP=$(awk '/nameserver/ {print $2}' /etc/resolv.conf | head -n1)
[03cfd6e]883        if [ -z "${NETIP[*]}" -o -z "${NETMASK[*]}" ]; then
[62e3bcf]884                errorAndLog "${FUNCNAME}(): Network not detected."
[7586ca3]885                exit 1
886        fi
[cc7eab7]887
888        # Variables de ejecución de Apache
889        # - APACHE_RUN_USER
890        # - APACHE_RUN_GROUP
[d168a46]891        if [ -f $APACHECFGDIR/envvars ]; then
892                source $APACHECFGDIR/envvars
[cc7eab7]893        fi
[d168a46]894        APACHE_RUN_USER=${APACHE_RUN_USER:-"$APACHEUSER"}
895        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"$APACHEGROUP"}
[73a1bd6]896
897        echoAndLog "${FUNCNAME}(): Default network device: $DEFAULTDEV."
[7586ca3]898}
899
900
901############################################################
[892606b9]902### Esqueleto para el Servicio pxe y contenedor tftpboot ###
903############################################################
904
[e0edc14]905function tftpConfigure()
906{
[109e8b2]907        echoAndLog "${FUNCNAME}(): Configuring TFTP service."
908        # Habilitar TFTP y reiniciar Inetd.
[8244351]909        if [ -n "$TFTPSERV" ]; then
[584b103]910                if [ -f $INETDCFGDIR/$TFTPSERV ]; then
911                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/$TFTPSERV
912                else
913                        service=$TFTPSERV
[b8969db]914                        $ENABLESERVICE; $STARTSERVICE
[584b103]915                fi
[8244351]916        fi
[53fba30]917        service=$INETDSERV
918        $ENABLESERVICE; $STARTSERVICE
[892606b9]919
[297df16]920        # comprobamos el servicio tftp
921        sleep 1
922        testPxe
[892606b9]923}
924
[0a735488]925# Comprueba que haya conexión al servicio TFTP/PXE.
[e0edc14]926function testPxe ()
927{
[297df16]928        echoAndLog "${FUNCNAME}(): Checking TFTP service... please wait."
[beaebf8]929        echo "test" >$TFTPCFGDIR/testpxe
930        tftp -v 127.0.0.1 -c get testpxe /tmp/testpxe && echoAndLog "TFTP service is OK." || errorAndLog "TFTP service is down."
931        rm -f $TFTPCFGDIR/testpxe /tmp/testpxe
[e4b1572]932}
933
934
935########################################################################
[5f21d34]936## Configuración servicio Samba
[8fc9552]937########################################################################
[e4b1572]938
939# Configurar servicios Samba.
[8fc9552]940function smbConfigure()
941{
[e0edc14]942        echoAndLog "${FUNCNAME}(): Configuring Samba service."
[8fc9552]943
[d168a46]944        backupFile $SAMBACFGDIR/smb.conf
[8fc9552]945       
[5f21d34]946        # Copiar plantailla de recursos para OpenGnsys
[c1e00e4]947        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
[d168a46]948                $WORKDIR/opengnsys/server/etc/smb-og.conf.tmpl > $SAMBACFGDIR/smb-og.conf
[813f617]949        # Configurar y recargar Samba"
[5f21d34]950        perl -pi -e "s/WORKGROUP/OPENGNSYS/; s/server string \=.*/server string \= OpenGnsys Samba Server/" $SAMBACFGDIR/smb.conf
[03cfd6e]951        if ! grep -q "smb-og" $SAMBACFGDIR/smb.conf; then
952                echo "include = $SAMBACFGDIR/smb-og.conf" >> $SAMBACFGDIR/smb.conf
953        fi
[53fba30]954        service=$SAMBASERV
955        $ENABLESERVICE; $STARTSERVICE
[8fc9552]956        if [ $? -ne 0 ]; then
[813f617]957                errorAndLog "${FUNCNAME}(): error while configure Samba"
[8fc9552]958                return 1
959        fi
[eb9424f]960        # Crear clave para usuario de acceso a los recursos.
[813f617]961        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | smbpasswd -a -s $OPENGNSYS_CLIENT_USER
[8fc9552]962
[813f617]963        echoAndLog "${FUNCNAME}(): Added Samba configuration."
[8fc9552]964        return 0
965}
966
967
[b6906f7]968########################################################################
[5f21d34]969## Configuración servicio Rsync
[e70925a]970########################################################################
971
972# Configurar servicio Rsync.
973function rsyncConfigure()
974{
975        echoAndLog "${FUNCNAME}(): Configuring Rsync service."
976
977        backupFile $RSYNCCFGDIR/rsyncd.conf
978
979        # Configurar acceso a Rsync.
980        sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENT_USER/g" \
981                $WORKDIR/opengnsys/repoman/etc/rsyncd.conf.tmpl > $RSYNCCFGDIR/rsyncd.conf
982        sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENT_USER/g" \
983            -e "s/CLIENTPASSWORD/$OPENGNSYS_CLIENT_PASSWD/g" \
984                $WORKDIR/opengnsys/repoman/etc/rsyncd.secrets.tmpl > $RSYNCCFGDIR/rsyncd.secrets
985        chown root.root $RSYNCCFGDIR/rsyncd.secrets
986        chmod 600 $RSYNCCFGDIR/rsyncd.secrets
987
988        # Habilitar Rsync y reiniciar Inetd.
989        if [ -n "$RSYNCSERV" ]; then
[4666588]990                if [ -f /etc/default/rsync ]; then
991                        perl -pi -e 's/RSYNC_ENABLE=.*/RSYNC_ENABLE=inetd/' /etc/default/rsync
992                fi
[f243a47]993                if [ -f $INETDCFGDIR/rsync ]; then
994                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/rsync
995                else
996                        cat << EOT > $INETDCFGDIR/rsync
997service rsync
998{
999        disable = no
1000        socket_type = stream
1001        wait = no
1002        user = root
1003        server = $(which rsync)
1004        server_args = --daemon
1005        log_on_failure += USERID
1006        flags = IPv6
1007}
1008EOT
1009                fi
[e70925a]1010                service=$RSYNCSERV $ENABLESERVICE
1011                service=$INETDSERV $STARTSERVICE
1012        fi
1013
1014        echoAndLog "${FUNCNAME}(): Added Rsync configuration."
1015        return 0
1016}
1017
1018       
1019########################################################################
[5f21d34]1020## Configuración servicio DHCP
[b6906f7]1021########################################################################
1022
[e4b1572]1023# Configurar servicios DHCP.
[7586ca3]1024function dhcpConfigure()
1025{
[836a7597]1026        echoAndLog "${FUNCNAME}(): Sample DHCP configuration."
[a555f49]1027
[d168a46]1028        local errcode=0
1029        local i=0
1030        local dev=""
1031
1032        backupFile $DHCPCFGDIR/dhcpd.conf
1033        for dev in ${DEVICE[*]}; do
[01a9904]1034                if [ -n "${SERVERIP[i]}" ]; then
[d168a46]1035                        backupFile $DHCPCFGDIR/dhcpd-$dev.conf
[e4b1572]1036                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1037                            -e "s/NETIP/${NETIP[i]}/g" \
1038                            -e "s/NETMASK/${NETMASK[i]}/g" \
1039                            -e "s/NETBROAD/${NETBROAD[i]}/g" \
1040                            -e "s/ROUTERIP/${ROUTERIP[i]}/g" \
[d168a46]1041                            -e "s/DNSIP/$DNSIP/g" \
1042                            $WORKDIR/opengnsys/server/etc/dhcpd.conf.tmpl > $DHCPCFGDIR/dhcpd-$dev.conf || errcode=1
1043                fi
1044                let i++
1045        done
1046        if [ $errcode -ne 0 ]; then
[b25fc47]1047                errorAndLog "${FUNCNAME}(): error while configuring DHCP server"
[a555f49]1048                return 1
1049        fi
[d168a46]1050        ln -f $DHCPCFGDIR/dhcpd-$DEFAULTDEV.conf $DHCPCFGDIR/dhcpd.conf
[53fba30]1051        service=$DHCPSERV
1052        $ENABLESERVICE; $STARTSERVICE
[d168a46]1053        echoAndLog "${FUNCNAME}(): Sample DHCP configured in \"$DHCPCFGDIR\"."
[a555f49]1054        return 0
[892606b9]1055}
1056
1057
[a01156a]1058#####################################################################
1059####### Funciones específicas de la instalación de Opengnsys
1060#####################################################################
1061
[5f21d34]1062# Copiar ficheros del OpenGnsys Web Console.
[7586ca3]1063function installWebFiles()
1064{
[2b793a8]1065        local COMPATDIR f
[7829e4e]1066        local SLIMFILE="slim-2.6.1.zip"
[8b8e948]1067        local SWAGGERFILE="swagger-ui-2.2.5.zip"
[2b793a8]1068
[dce072b]1069        echoAndLog "${FUNCNAME}(): Installing web files..."
[2b793a8]1070        # Copiar ficheros.
1071        cp -a $WORKDIR/opengnsys/admin/WebConsole/* $INSTALL_TARGET/www   #*/ comentario para Doxygen.
[7586ca3]1072        if [ $? != 0 ]; then
[dce072b]1073                errorAndLog "${FUNCNAME}(): Error copying web files."
[7586ca3]1074                exit 1
1075        fi
1076        find $INSTALL_TARGET/www -name .svn -type d -exec rm -fr {} \; 2>/dev/null
[7829e4e]1077
[1635f45]1078        # Descomprimir librerías: Slim y Swagger-UI.
[7829e4e]1079        unzip -o $WORKDIR/opengnsys/admin/$SLIMFILE -d $INSTALL_TARGET/www/rest
[8b8e948]1080        unzip -o $WORKDIR/opengnsys/admin/$SWAGGERFILE -d $INSTALL_TARGET/www/rest
[7829e4e]1081
[2b793a8]1082        # Compatibilidad con dispositivos móviles.
1083        COMPATDIR="$INSTALL_TARGET/www/principal"
1084        for f in acciones administracion aula aulas hardwares imagenes menus repositorios softwares; do
1085                sed 's/clickcontextualnodo/clicksupnodo/g' $COMPATDIR/$f.php > $COMPATDIR/$f.device.php
1086        done
1087        cp -a $COMPATDIR/imagenes.device.php $COMPATDIR/imagenes.device4.php
[7586ca3]1088        # Cambiar permisos para ficheros especiales.
[e6d22c6]1089        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/images/{fotos,iconos}
[b7bd0df]1090        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/tmp/
[0645906]1091        # Ficheros de log de la API REST.
1092        touch $INSTALL_TARGET/log/{ogagent,remotepc,rest}.log
1093        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/log/{ogagent,remotepc,rest}.log
[2b793a8]1094
[dce072b]1095        echoAndLog "${FUNCNAME}(): Web files installed successfully."
[7586ca3]1096}
1097
[ec045b1]1098# Copiar ficheros en la zona de descargas de OpenGnsys Web Console.
1099function installDownloadableFiles()
1100{
1101        local FILENAME=ogagentpkgs-$INSTVERSION.tar.gz
1102        local TARGETFILE=$WORKDIR/$FILENAME
1103 
1104        # Descargar archivo comprimido, si es necesario.
1105        if [ -s $PROGRAMDIR/$FILENAME ]; then
1106                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
1107                mv $PROGRAMDIR/$FILENAME $TARGETFILE
1108        else
1109                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
[d5cbfa8]1110                curl $DOWNLOADURL/$FILENAME -o $TARGETFILE
[ec045b1]1111        fi
1112        if [ ! -s $TARGETFILE ]; then
1113                errorAndLog "${FUNCNAME}(): Cannot download $FILENAME"
1114                return 1
1115        fi
1116       
1117        # Descomprimir fichero en zona de descargas.
1118        tar xvzf $TARGETFILE -C $INSTALL_TARGET/www/descargas
1119        if [ $? != 0 ]; then
1120                errorAndLog "${FUNCNAME}(): Error uncompressing archive."
1121                exit 1
1122        fi
1123}
1124
[7586ca3]1125# Configuración específica de Apache.
[73a1bd6]1126function installWebConsoleApacheConf()
[a01156a]1127{
1128        if [ $# -ne 2 ]; then
[dce072b]1129                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]1130                exit 1
1131        fi
1132
[f9e3393]1133        local path_opengnsys_base="$1"
1134        local path_apache2_confd="$2"
[30837bb]1135        local CONSOLEDIR=${path_opengnsys_base}/www
[a01156a]1136
[892606b9]1137        if [ ! -d $path_apache2_confd ]; then
[dce072b]1138                errorAndLog "${FUNCNAME}(): path to apache2 conf.d can not found, verify your server installation"
[892606b9]1139                return 1
1140        fi
1141
[7586ca3]1142        mkdir -p $path_apache2_confd/{sites-available,sites-enabled}
[892606b9]1143
[dce072b]1144        echoAndLog "${FUNCNAME}(): creating apache2 config file.."
[a01156a]1145
[3ce53a7]1146        # Activar HTTPS.
[7825e9e]1147        $APACHESSLMOD
[643ca8c]1148        $APACHEENABLESSL
1149        $APACHEMAKECERT
[7829e4e]1150        # Activar módulo Rewrite.
1151        $APACHEREWRITEMOD
[30837bb]1152        # Genera configuración de consola web a partir del fichero plantilla.
[f9e3393]1153        if [ -n "$(apachectl -v | grep "2\.[0-2]")" ]; then
1154                # Configuración para versiones anteriores de Apache.
[6f4d39b]1155                sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
[f3dde7e]1156                        $WORKDIR/opengnsys/server/etc/apache-prev2.4.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}
[f9e3393]1157        else
1158                # Configuración específica a partir de Apache 2.4
[6f4d39b]1159                sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
[f3dde7e]1160                        $WORKDIR/opengnsys/server/etc/apache.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}.conf
[f9e3393]1161        fi
[643ca8c]1162        $APACHEENABLEOG
[a01156a]1163        if [ $? -ne 0 ]; then
[dce072b]1164                errorAndLog "${FUNCNAME}(): config file can't be linked to apache conf, verify your server installation"
[a01156a]1165                return 1
1166        fi
[103bc82]1167        echoAndLog "${FUNCNAME}(): config file created and linked, restarting apache daemon"
1168        service=$APACHESERV
1169        $ENABLESERVICE; $STARTSERVICE
1170        return 0
[a01156a]1171}
1172
[8fc9552]1173
[5d6bf97]1174# Crear documentación Doxygen para la consola web.
1175function makeDoxygenFiles()
1176{
1177        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
1178        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
1179                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
1180        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
1181                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
[ead38fb]1182                return 1
[5d6bf97]1183        fi
1184        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
1185        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/api
1186        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
1187}
1188
1189
[a01156a]1190# Crea la estructura base de la instalación de opengnsys
[eb9424f]1191function createDirs()
[a01156a]1192{
1193        if [ $# -ne 1 ]; then
[dce072b]1194                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]1195                exit 1
1196        fi
1197
[eb9424f]1198        local path_opengnsys_base="$1"
[a01156a]1199
[eb9424f]1200        # Crear estructura de directorios.
[dce072b]1201        echoAndLog "${FUNCNAME}(): creating directory paths in $path_opengnsys_base"
[a01156a]1202        mkdir -p $path_opengnsys_base
1203        mkdir -p $path_opengnsys_base/bin
[5c33840]1204        mkdir -p $path_opengnsys_base/client
[49c6891]1205        mkdir -p $path_opengnsys_base/doc
[5c33840]1206        mkdir -p $path_opengnsys_base/etc
[a01156a]1207        mkdir -p $path_opengnsys_base/lib
[1cc5697]1208        mkdir -p $path_opengnsys_base/log/clients
[eb9424f]1209        ln -fs $path_opengnsys_base/log /var/log/opengnsys
[7586ca3]1210        mkdir -p $path_opengnsys_base/sbin
[a01156a]1211        mkdir -p $path_opengnsys_base/www
[d7ece95]1212        mkdir -p $path_opengnsys_base/images/groups
[87c7b02]1213        mkdir -p $TFTPCFGDIR
[63fd1ba]1214        ln -fs $TFTPCFGDIR $path_opengnsys_base/tftpboot
[cfad47b]1215        mkdir -p $path_opengnsys_base/tftpboot/menu.lst
[a01156a]1216        if [ $? -ne 0 ]; then
[dce072b]1217                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
[a01156a]1218                return 1
1219        fi
1220
[eb9424f]1221        # Crear usuario ficticio.
1222        if id -u $OPENGNSYS_CLIENT_USER &>/dev/null; then
1223                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENT_USER\" is already created"
1224        else
[5f21d34]1225                echoAndLog "${FUNCNAME}(): creating OpenGnsys user"
[eb9424f]1226                useradd $OPENGNSYS_CLIENT_USER 2>/dev/null
1227                if [ $? -ne 0 ]; then
[5f21d34]1228                        errorAndLog "${FUNCNAME}(): error creating OpenGnsys user"
[eb9424f]1229                        return 1
1230                fi
1231        fi
1232
1233        # Establecer los permisos básicos.
1234        echoAndLog "${FUNCNAME}(): setting directory permissions"
[5eb61a6]1235        chmod -R 775 $path_opengnsys_base/{log/clients,images}
1236        chown -R :$OPENGNSYS_CLIENT_USER $path_opengnsys_base/{log/clients,images}
[eb9424f]1237        if [ $? -ne 0 ]; then
1238                errorAndLog "${FUNCNAME}(): error while setting permissions"
1239                return 1
1240        fi
1241
[7669bca]1242        # Mover el fichero de registro de instalación al directorio de logs.
[acfb07d]1243        echoAndLog "${FUNCNAME}(): moving installation log file"
1244        mv $LOG_FILE $OGLOGFILE && LOG_FILE=$OGLOGFILE
[7669bca]1245        chmod 600 $LOG_FILE
[acfb07d]1246
[dce072b]1247        echoAndLog "${FUNCNAME}(): directory paths created"
[a01156a]1248        return 0
1249}
1250
[463a1d49]1251# Copia ficheros de configuración y ejecutables genéricos del servidor.
[73a1bd6]1252function copyServerFiles ()
[e0edc14]1253{
[463a1d49]1254        if [ $# -ne 1 ]; then
[879689f]1255                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[463a1d49]1256                exit 1
1257        fi
1258
[7caf5a7c]1259        local path_opengnsys_base="$1"
[463a1d49]1260
[a43e90d]1261        # Lista de ficheros y directorios origen y de directorios destino.
[cfad47b]1262        local SOURCES=( server/tftpboot \
[7caf5a7c]1263                        server/bin \
1264                        repoman/bin \
[3e7d77b]1265                        server/lib \
[42a0e41]1266                        admin/Sources/Services/ogAdmServerAux
1267                        admin/Sources/Services/ogAdmRepoAux
[7caf5a7c]1268                        installer/opengnsys_uninstall.sh \
1269                        installer/opengnsys_update.sh \
[6777e3e]1270                        installer/opengnsys_export.sh \
1271                        installer/opengnsys_import.sh \
[7caf5a7c]1272                        doc )
[cfad47b]1273        local TARGETS=( tftpboot \
[7caf5a7c]1274                        bin \
1275                        bin \
[3e7d77b]1276                        lib \
[42a0e41]1277                        sbin \
1278                        sbin \
[7caf5a7c]1279                        lib \
1280                        lib \
[6777e3e]1281                        lib \
1282                        lib \
[7caf5a7c]1283                        doc )
[463a1d49]1284
1285        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
[879689f]1286                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
[463a1d49]1287                exit 1
1288        fi
1289
[a43e90d]1290        # Copiar ficheros.
[879689f]1291        echoAndLog "${FUNCNAME}(): copying files to server directories"
[f2bb433]1292
[8457092]1293        pushd $WORKDIR/opengnsys
[463a1d49]1294        local i
1295        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
1296                if [ -f "${SOURCES[$i]}" ]; then
[879689f]1297                        echoAndLog "Copying ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[b5aae72]1298                        cp -a "${SOURCES[$i]}" "${path_opengnsys_base}/${TARGETS[$i]}"
[8457092]1299                elif [ -d "${SOURCES[$i]}" ]; then
[879689f]1300                        echoAndLog "Copying content of ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[8457092]1301                        cp -a "${SOURCES[$i]}"/* "${path_opengnsys_base}/${TARGETS[$i]}"
1302        else
[346eaee]1303                        warningAndLog "Unable to copy ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[463a1d49]1304                fi
1305        done
[a43e90d]1306
[7586ca3]1307        popd
[892606b9]1308}
1309
[7586ca3]1310####################################################################
[5eb61a6]1311### Funciones de compilación de código fuente de servicios
[7586ca3]1312####################################################################
1313
[5f21d34]1314# Compilar los servicios de OpenGnsys
[7586ca3]1315function servicesCompilation ()
1316{
[13a01a7]1317        local hayErrores=0
[0795938]1318
[5f21d34]1319        # Compilar OpenGnsys Server
1320        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Admin Server"
[7b61735]1321        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
[d168a46]1322        make && mv ogAdmServer $INSTALL_TARGET/sbin
[13a01a7]1323        if [ $? -ne 0 ]; then
[5f21d34]1324                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Server"
[13a01a7]1325                hayErrores=1
1326        fi
[7586ca3]1327        popd
[5f21d34]1328        # Compilar OpenGnsys Repository Manager
1329        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Repository Manager"
[7b61735]1330        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
[d168a46]1331        make && mv ogAdmRepo $INSTALL_TARGET/sbin
[13a01a7]1332        if [ $? -ne 0 ]; then
[5f21d34]1333                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Repository Manager"
[13a01a7]1334                hayErrores=1
1335        fi
[8125e7c]1336        popd
[5f21d34]1337        # Compilar OpenGnsys Agent
1338        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Agent"
[7b61735]1339        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
[d168a46]1340        make && mv ogAdmAgent $INSTALL_TARGET/sbin
[4984660]1341        if [ $? -ne 0 ]; then
[5f21d34]1342                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Agent"
[4984660]1343                hayErrores=1
1344        fi
1345        popd   
[5f21d34]1346        # Compilar OpenGnsys Client
1347        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Admin Client"
[7b61735]1348        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
[2338c95f]1349        make && mv ogAdmClient ../../../../client/shared/bin
[13a01a7]1350        if [ $? -ne 0 ]; then
[5f21d34]1351                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Client"
[13a01a7]1352                hayErrores=1
1353        fi
[318efac]1354        popd
[13a01a7]1355
1356        return $hayErrores
[b6906f7]1357}
1358
[7b61735]1359####################################################################
1360### Funciones de copia de la Interface de administración
1361####################################################################
1362
1363# Copiar carpeta de Interface
[c1e00e4]1364function copyInterfaceAdm ()
[7b61735]1365{
1366        local hayErrores=0
1367       
[fbd9bcc]1368        # Crear carpeta y copiar Interface
[7b61735]1369        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
[fbd9bcc]1370        cp -ar $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client/interfaceAdm
[7b61735]1371        if [ $? -ne 0 ]; then
1372                echoAndLog "${FUNCNAME}(): error while copying Administration Interface Folder"
1373                hayErrores=1
1374        fi
[b6f1726]1375        chown $OPENGNSYS_CLIENT_USER:$OPENGNSYS_CLIENT_USER $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
[f6c1d2b]1376        chmod 700 $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
[7b61735]1377
1378        return $hayErrores
1379}
[b6906f7]1380
[892606b9]1381####################################################################
1382### Funciones instalacion cliente opengnsys
1383####################################################################
1384
[73a1bd6]1385function copyClientFiles()
[7586ca3]1386{
[d168a46]1387        local errstatus=0
[a555f49]1388
[5f21d34]1389        echoAndLog "${FUNCNAME}(): Copying OpenGnsys Client files."
[73a1bd6]1390        cp -a $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
[d47d38d]1391        if [ $? -ne 0 ]; then
[9ef8920]1392                errorAndLog "${FUNCNAME}(): error while copying client estructure"
[d168a46]1393                errstatus=1
[9ef8920]1394        fi
[d47d38d]1395        find $INSTALL_TARGET/client -name .svn -type d -exec rm -fr {} \; 2>/dev/null
[9ef8920]1396       
[5f21d34]1397        echoAndLog "${FUNCNAME}(): Copying OpenGnsys Cloning Engine files."
[d47d38d]1398        mkdir -p $INSTALL_TARGET/client/lib/engine/bin
[73a1bd6]1399        cp -a $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
[a555f49]1400        if [ $? -ne 0 ]; then
1401                errorAndLog "${FUNCNAME}(): error while copying engine files"
[d168a46]1402                errstatus=1
[a555f49]1403        fi
[9ef8920]1404       
[d168a46]1405        if [ $errstatus -eq 0 ]; then
[9ef8920]1406                echoAndLog "${FUNCNAME}(): client copy files success."
1407        else
1408                errorAndLog "${FUNCNAME}(): client copy files with errors"
1409        fi
1410
[d168a46]1411        return $errstatus
[463a1d49]1412}
1413
1414
[5f21d34]1415# Crear cliente OpenGnsys.
[5ad5dcc]1416function clientCreate()
[813f617]1417{
[6019b12]1418        if [ $# -ne 1 ]; then
1419                errorAndLog "${FUNCNAME}(): invalid number of parameters"
1420                exit 1
1421        fi
1422
1423        local FILENAME="$1"
[0b85cc93]1424        local TARGETFILE=$INSTALL_TARGET/lib/$FILENAME
[d168a46]1425 
[79c26a8]1426        # Descargar cliente, si es necesario.
1427        if [ -s $PROGRAMDIR/$FILENAME ]; then
1428                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
1429                mv $PROGRAMDIR/$FILENAME $TARGETFILE
1430        else
[ec045b1]1431                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
[6019b12]1432                oglivecli download $FILENAME
[79c26a8]1433        fi
[0b85cc93]1434        if [ ! -s $TARGETFILE ]; then
[ec045b1]1435                errorAndLog "${FUNCNAME}(): Error loading $FILENAME"
[813f617]1436                return 1
1437        fi
[1893b9d]1438
[79c26a8]1439        # Montar imagen, copiar cliente ogclient y desmontar.
[0496417]1440        echoAndLog "${FUNCNAME}(): Installing ogLive Client"
[6ef01d9]1441        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | \
[6019b12]1442                        oglivecli install $FILENAME
[1893b9d]1443        # Adaptar permisos.
[beaebf8]1444        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/tftpboot/menu.lst
[6ef01d9]1445
[813f617]1446        echoAndLog "${FUNCNAME}(): Client generation success"
1447}
1448
1449
[5f21d34]1450# Configuración básica de servicios de OpenGnsys
[cc7eab7]1451function openGnsysConfigure()
1452{
[d168a46]1453        local i=0
1454        local dev=""
[7d4ce64]1455        local CONSOLEURL
[d168a46]1456
[9ee62ad]1457        echoAndLog "${FUNCNAME}(): Copying init files."
[42a0e41]1458        cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
1459        cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.default /etc/default/opengnsys
[b8969db]1460        # Deshabilitar servicios de BitTorrent si no están instalados.
1461        if [ ! -e /usr/bin/bttrack ]; then
[fdab5d0]1462                sed -i 's/RUN_BTTRACKER="yes"/RUN_BTTRACKER="no"/; s/RUN_BTSEEDER="yes"/RUN_BTSEEDER="no"/' \
[b8969db]1463                        /etc/default/opengnsys
1464        fi
[9ee62ad]1465        echoAndLog "${FUNCNAME}(): Creating cron files."
[57cf15b]1466        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/opengnsys.cron ] && $INSTALL_TARGET/bin/opengnsys.cron" > /etc/cron.d/opengnsys
[9ee62ad]1467        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
[8fc9552]1468        echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
[dc762088]1469        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/deletepreimage ] && $INSTALL_TARGET/bin/deletepreimage" > /etc/cron.d/imagedelete
[0645906]1470        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/ogagentqueue.cron ] && $INSTALL_TARGET/bin/ogagentqueue.cron" > /etc/cron.d/ogagentqueue
[d168a46]1471
[700299b]1472        echoAndLog "${FUNCNAME}(): Creating logrotate configuration file."
1473        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
1474                $WORKDIR/opengnsys/server/etc/logrotate.tmpl > /etc/logrotate.d/opengnsys
1475
[5f21d34]1476        echoAndLog "${FUNCNAME}(): Creating OpenGnsys config files."
[d168a46]1477        for dev in ${DEVICE[*]}; do
1478                if [ -n "${SERVERIP[i]}" ]; then
1479                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1480                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1481                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1482                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
1483                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer/ogAdmServer.cfg > $INSTALL_TARGET/etc/ogAdmServer-$dev.cfg
1484                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
[f9b5714]1485                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
[d168a46]1486                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo/ogAdmRepo.cfg > $INSTALL_TARGET/etc/ogAdmRepo-$dev.cfg
1487                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1488                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1489                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1490                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
1491                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent/ogAdmAgent.cfg > $INSTALL_TARGET/etc/ogAdmAgent-$dev.cfg
[1a2fa9d8]1492                        CONSOLEURL="https://${SERVERIP[i]}/opengnsys"
[d168a46]1493                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1494                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1495                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1496                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
[b22305e]1497                            -e "s/OPENGNSYSURL/${CONSOLEURL//\//\\/}/g" \
[d168a46]1498                                $INSTALL_TARGET/www/controlacceso.php > $INSTALL_TARGET/www/controlacceso-$dev.php
1499                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
[d7f8305]1500                            -e "s/OPENGNSYSURL/${CONSOLEURL//\//\\/}/g" \
[d168a46]1501                                $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient/ogAdmClient.cfg > $INSTALL_TARGET/client/etc/ogAdmClient-$dev.cfg
[7d4ce64]1502                        if [ "$dev" == "$DEFAULTDEV" ]; then
[1a2fa9d8]1503                                OPENGNSYS_CONSOLEURL="$CONSOLEURL"
[7d4ce64]1504                        fi
[d168a46]1505                fi
1506                let i++
1507        done
1508        ln -f $INSTALL_TARGET/etc/ogAdmServer-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmServer.cfg
1509        ln -f $INSTALL_TARGET/etc/ogAdmRepo-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmRepo.cfg
1510        ln -f $INSTALL_TARGET/etc/ogAdmAgent-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmAgent.cfg
1511        ln -f $INSTALL_TARGET/client/etc/ogAdmClient-$DEFAULTDEV.cfg $INSTALL_TARGET/client/etc/ogAdmClient.cfg
1512        ln -f $INSTALL_TARGET/www/controlacceso-$DEFAULTDEV.php $INSTALL_TARGET/www/controlacceso.php
1513        chown root:root $INSTALL_TARGET/etc/{ogAdmServer,ogAdmAgent}*.cfg
1514        chmod 600 $INSTALL_TARGET/etc/{ogAdmServer,ogAdmAgent}*.cfg
1515        chown $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/controlacceso*.php
1516        chmod 600 $INSTALL_TARGET/www/controlacceso*.php
[1f7b2d0]1517
[a3855dc]1518        # Configuración del motor de clonación.
1519        # - Zona horaria del servidor.
1520        TZ=$(timedatectl status|awk -F"[:()]" '/Time.*zone/ {print $2}')
1521        cat << EOT >> $INSTALL_TARGET/client/etc/engine.cfg
1522# OpenGnsys Server timezone.
1523TZ="${TZ// /}"
1524EOT
1525
[1f7b2d0]1526        # Revisar permisos generales.
1527        if [ -x $INSTALL_TARGET/bin/checkperms ]; then
1528                echoAndLog "${FUNCNAME}(): Checking permissions."
[6019b12]1529                OPENGNSYS_DIR="$INSTALL_TARGET" OPENGNSYS_USER="$OPENGNSYS_CLIENT_USER" APACHE_USER="$APACHE_RUN_USER" APACHE_GROUP="$APACHE_RUN_GROUP" checkperms
[1f7b2d0]1530        fi
1531
[4e19f13]1532        # Evitar inicio de duplicado en Ubuntu 14.04 (Upstart y SysV Init).
[c7ade22]1533        if [ -f /etc/init/${MYSQLSERV}.conf -a -n "$(which initctl 2>/dev/null)" ]; then
[4e19f13]1534                service=$MYSQLSERV
1535                $DISABLESERVICE
1536        fi
1537
[5f21d34]1538        echoAndLog "${FUNCNAME}(): Starting OpenGnsys services."
[53fba30]1539        service="opengnsys"
1540        $ENABLESERVICE; $STARTSERVICE
[cc7eab7]1541}
1542
[b6906f7]1543
[a01156a]1544#####################################################################
[180a07dd]1545#######  Función de resumen informativo de la instalación
1546#####################################################################
1547
[813f617]1548function installationSummary()
1549{
[eb9424f]1550        # Crear fichero de versión y revisión, si no existe.
1551        local VERSIONFILE="$INSTALL_TARGET/doc/VERSION.txt"
[5f21d34]1552        [ -f $VERSIONFILE ] || echo "OpenGnsys Server" >$VERSIONFILE
[130bdbf]1553        # Incluir datos de revisión, si se está instaladno desde el repositorio
1554        # de código o si no está incluida en el fichero de versión.
1555        if [ $USESVN -eq 1 ] || [ -z "$(awk '$3~/r[0-9]*/ {print}' $VERSIONFILE)" ]; then
1556                local REVISION=$(LANG=C svn info $SVN_URL|awk '/Rev:/ {print "r"$4}')
1557                perl -pi -e "s/($| r[0-9]*)/ $REVISION/" $VERSIONFILE
1558        fi
[eb9424f]1559
1560        # Mostrar información.
[180a07dd]1561        echo
[5f21d34]1562        echoAndLog "OpenGnsys Installation Summary"
[180a07dd]1563        echo       "=============================="
[eb9424f]1564        echoAndLog "Project version:                  $(cat $VERSIONFILE 2>/dev/null)"
[49c6891]1565        echoAndLog "Installation directory:           $INSTALL_TARGET"
[acfb07d]1566        echoAndLog "Installation log file:            $LOG_FILE"
[49c6891]1567        echoAndLog "Repository directory:             $INSTALL_TARGET/images"
[d168a46]1568        echoAndLog "DHCP configuration directory:     $DHCPCFGDIR"
[87c7b02]1569        echoAndLog "TFTP configuration directory:     $TFTPCFGDIR"
[6019b12]1570        echoAndLog "Installed ogLive client(s):       $(oglivecli list | awk '{print $2}')"
[87c7b02]1571        echoAndLog "Samba configuration directory:    $SAMBACFGDIR"
[49c6891]1572        echoAndLog "Web Console URL:                  $OPENGNSYS_CONSOLEURL"
[35b0ef1]1573        echoAndLog "Web Console access data:          specified in installer script"
[b8969db]1574        if grep -q "^RUN_BTTRACK.*no" /etc/default/opengnsys; then
1575                echoAndLog "BitTorrent service is disabled."
1576        fi
[180a07dd]1577        echo
1578        echoAndLog "Post-Installation Instructions:"
1579        echo       "==============================="
[663c6625]1580        echoAndLog "Firewall service has been disabled and SELinux mode set to"
[5f21d34]1581        echoAndLog "   permissive during OpenGnsys installation. Please check"
[64f4ada]1582        echoAndLog "   ${FIREWALLSERV:-firewall} and SELinux configuration, if needed."
[4faafcd]1583        echoAndLog "It's strongly recommended to synchronize this server with an NTP server."
[180a07dd]1584        echoAndLog "Review or edit all configuration files."
[c5ce04c]1585        echoAndLog "Insert DHCP configuration data and restart service."
[af5efd6]1586        echoAndLog "Optional: Log-in as Web Console admin user."
1587        echoAndLog " - Review default Organization data and assign access to users."
[180a07dd]1588        echoAndLog "Log-in as Web Console organization user."
[5f21d34]1589        echoAndLog " - Insert OpenGnsys data (labs, computers, menus, etc)."
[180a07dd]1590echo
1591}
1592
1593
1594
1595#####################################################################
[5f21d34]1596####### Proceso de instalación de OpenGnsys
[a01156a]1597#####################################################################
1598
[5f21d34]1599echoAndLog "OpenGnsys installation begins at $(date)"
[6090a2d]1600pushd $WORKDIR
[cc7eab7]1601
[af5efd6]1602# Detectar datos iniciales de auto-configuración del instalador.
[d168a46]1603autoConfigure
1604
1605# Detectar parámetros de red y comprobar si hay conexión.
1606getNetworkSettings
1607if [ $? -ne 0 ]; then
1608        errorAndLog "Error reading default network settings."
1609        exit 1
1610fi
[07c3a59]1611checkNetworkConnection
1612if [ $? -ne 0 ]; then
1613        errorAndLog "Error connecting to server. Causes:"
1614        errorAndLog " - Network is unreachable, review devices parameters."
1615        errorAndLog " - You are inside a private network, configure the proxy service."
1616        errorAndLog " - Server is temporally down, try agian later."
1617        exit 1
1618fi
[7586ca3]1619
[5f21d34]1620# Detener servicios de OpenGnsys, si están activos previamente.
[e0edc14]1621[ -f /etc/init.d/opengnsys ] && /etc/init.d/opengnsys stop
1622
[318efac]1623# Actualizar repositorios
[83518d5]1624updatePackageList
[318efac]1625
[b6906f7]1626# Instalación de dependencias (paquetes de sistema operativo).
[a01156a]1627declare -a notinstalled
1628checkDependencies DEPENDENCIES notinstalled
1629if [ $? -ne 0 ]; then
1630        installDependencies notinstalled
1631        if [ $? -ne 0 ]; then
1632                echoAndLog "Error while installing some dependeces, please verify your server installation before continue"
1633                exit 1
1634        fi
1635fi
[109e8b2]1636if [ -n "$INSTALLEXTRADEPS" ]; then
1637        echoAndLog "Installing extra dependencies"
1638        for (( i=0; i<${#INSTALLEXTRADEPS[*]}; i++ )); do
1639                eval ${INSTALLEXTRADEPS[i]}
1640        done
1641fi     
[a01156a]1642
[ff6c349]1643# Detectar datos de auto-configuración después de instalar paquetes.
1644autoConfigurePost
1645
[5f21d34]1646# Arbol de directorios de OpenGnsys.
[eb9424f]1647createDirs ${INSTALL_TARGET}
[a01156a]1648if [ $? -ne 0 ]; then
1649        errorAndLog "Error while creating directory paths!"
1650        exit 1
1651fi
[b6906f7]1652
[1e7eaab]1653# Si es necesario, descarga el repositorio de código en directorio temporal
[49c6891]1654if [ $USESVN -eq 1 ]; then
[1e7eaab]1655        svnExportCode $SVN_URL
1656        if [ $? -ne 0 ]; then
1657                errorAndLog "Error while getting code from svn"
1658                exit 1
1659        fi
1660else
1661        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
[a01156a]1662fi
1663
[5f21d34]1664# Compilar código fuente de los servicios de OpenGnsys.
[b6906f7]1665servicesCompilation
[13a01a7]1666if [ $? -ne 0 ]; then
1667        errorAndLog "Error while compiling OpenGnsys services"
1668        exit 1
1669fi
[b6906f7]1670
[7b61735]1671# Copiar carpeta Interface entre administración y motor de clonación.
[c1e00e4]1672copyInterfaceAdm
[7b61735]1673if [ $? -ne 0 ]; then
[c1e00e4]1674        errorAndLog "Error while copying Administration Interface"
[7b61735]1675        exit 1
1676fi
1677
[e70925a]1678# Configuración de TFTP.
[318efac]1679tftpConfigure
[b6906f7]1680
[e70925a]1681# Configuración de Samba.
[8fc9552]1682smbConfigure
1683if [ $? -ne 0 ]; then
[c1e00e4]1684        errorAndLog "Error while configuring Samba server!"
[8fc9552]1685        exit 1
1686fi
1687
[e70925a]1688# Configuración de Rsync.
1689rsyncConfigure
1690
1691# Configuración ejemplo DHCP.
[b6906f7]1692dhcpConfigure
[a555f49]1693if [ $? -ne 0 ]; then
1694        errorAndLog "Error while copying your dhcp server files!"
1695        exit 1
1696fi
[b6906f7]1697
[5f21d34]1698# Copiar ficheros de servicios OpenGnsys Server.
[73a1bd6]1699copyServerFiles ${INSTALL_TARGET}
[463a1d49]1700if [ $? -ne 0 ]; then
1701        errorAndLog "Error while copying the server files!"
1702        exit 1
1703fi
[730bde5]1704INSTVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt)
[463a1d49]1705
[5f21d34]1706# Instalar base de datos de OpenGnsys Admin.
[5cc52295]1707isInArray notinstalled "mysql-server" || isInArray notinstalled "mariadb-server"
[b6906f7]1708if [ $? -eq 0 ]; then
[094ac0d]1709        # Habilitar gestor de base de datos (MySQL, si falla, MariaDB).
1710        service=$MYSQLSERV
1711        $ENABLESERVICE
1712        if [ $? != 0 ]; then
1713                service=$MARIADBSERV
1714                $ENABLESERVICE
1715        fi
1716        # Activar gestor de base de datos.
[0f8100d]1717        $STARTSERVICE
[094ac0d]1718        # Asignar clave del usuario "root".
[09bf701]1719        mysqlSetRootPassword "${MYSQL_ROOT_PASSWORD}"
[b6906f7]1720else
[094ac0d]1721        # Si ya está instalado el gestor de bases de datos, obtener clave de "root",
[b6906f7]1722        mysqlGetRootPassword
1723fi
[463a1d49]1724
[09bf701]1725mysqlTestConnection "${MYSQL_ROOT_PASSWORD}"
[a01156a]1726if [ $? -ne 0 ]; then
1727        errorAndLog "Error while connection to mysql"
1728        exit 1
1729fi
[09bf701]1730mysqlDbExists ${OPENGNSYS_DATABASE}
[a01156a]1731if [ $? -ne 0 ]; then
[cc7eab7]1732        echoAndLog "Creating Web Console database"
[09bf701]1733        mysqlCreateDb ${OPENGNSYS_DATABASE}
[a01156a]1734        if [ $? -ne 0 ]; then
[cc7eab7]1735                errorAndLog "Error while creating Web Console database"
[a01156a]1736                exit 1
1737        fi
1738else
[cc7eab7]1739        echoAndLog "Web Console database exists, ommiting creation"
[a01156a]1740fi
1741
[09bf701]1742mysqlCheckUserExists ${OPENGNSYS_DB_USER}
[a01156a]1743if [ $? -ne 0 ]; then
1744        echoAndLog "Creating user in database"
[09bf701]1745        mysqlCreateAdminUserToDb ${OPENGNSYS_DATABASE} ${OPENGNSYS_DB_USER} "${OPENGNSYS_DB_PASSWD}"
[a01156a]1746        if [ $? -ne 0 ]; then
[cc7eab7]1747                errorAndLog "Error while creating database user"
[a01156a]1748                exit 1
1749        fi
1750
1751fi
1752
[09bf701]1753mysqlCheckDbIsEmpty ${OPENGNSYS_DATABASE}
[a01156a]1754if [ $? -eq 0 ]; then
1755        echoAndLog "Creating tables..."
[892606b9]1756        if [ -f $WORKDIR/$OPENGNSYS_DB_CREATION_FILE ]; then
[09bf701]1757                mysqlImportSqlFileToDb ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_CREATION_FILE
[a01156a]1758        else
[892606b9]1759                errorAndLog "Unable to locate $WORKDIR/$OPENGNSYS_DB_CREATION_FILE!!"
[a01156a]1760                exit 1
1761        fi
[bc7dfe7]1762else
1763        # Si existe fichero ogBDAdmin-VersLocal-VersRepo.sql; aplicar cambios.
1764        REPOVERSION=$(awk '{print $2}' $WORKDIR/opengnsys/doc/VERSION.txt)
[295b4ab]1765        OPENGNSYS_DB_UPDATE_FILE="opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-$REPOVERSION.sql"
1766        if [ -f $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE ]; then
[bc7dfe7]1767                echoAndLog "Updating tables from version $INSTVERSION to $REPOVERSION"
[09bf701]1768                mysqlImportSqlFileToDb ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE
[bc7dfe7]1769        else
1770                echoAndLog "Database unchanged."
1771        fi
[a01156a]1772fi
[09bf701]1773# Eliminar fichero temporal con credenciales de acceso a MySQL.
1774rm -f $TMPMYCNF
[a01156a]1775
[5f21d34]1776# Copiando páqinas web.
[7586ca3]1777installWebFiles
[ec045b1]1778# Descargar/descomprimir archivos descargables.
1779installDownloadableFiles
[5d6bf97]1780# Generar páqinas web de documentación de la API
1781makeDoxygenFiles
[a01156a]1782
[5f21d34]1783# Creando configuración de Apache.
[5fcf180]1784installWebConsoleApacheConf $INSTALL_TARGET $APACHECFGDIR
[a01156a]1785if [ $? -ne 0 ]; then
[5f21d34]1786        errorAndLog "Error configuring Apache for OpenGnsys Admin"
[a01156a]1787        exit 1
1788fi
1789
1790popd
[892606b9]1791
[9ef8920]1792# Crear la estructura de los accesos al servidor desde el cliente (shared)
[73a1bd6]1793copyClientFiles
[9ef8920]1794if [ $? -ne 0 ]; then
1795        errorAndLog "Error creating client structure"
1796fi
1797
[5f21d34]1798# Crear la estructura del cliente de OpenGnsys.
[6019b12]1799for i in $OGLIVE; do
1800        if ! clientCreate "$i"; then
1801                errorAndLog "Error creating client $i"
1802                exit 1
1803        fi
1804done
[892606b9]1805
[5f21d34]1806# Configuración de servicios de OpenGnsys
[65245d1]1807openGnsysConfigure
1808
[180a07dd]1809# Mostrar sumario de la instalación e instrucciones de post-instalación.
1810installationSummary
1811
[077dd7c5]1812#rm -rf $WORKDIR
[5f21d34]1813echoAndLog "OpenGnsys installation finished at $(date)"
[05d2e03]1814exit 0
[2308fc7]1815
Note: See TracBrowser for help on using the repository browser.